# Generated by planetlab build on Tue Jan 19 09:09:49 CET 2016
%define distro Fedora
%define distrorelease 14
%define distroname f14
%define pldistro onelab
%define plrelease 5.2
# use MD5 and gzip for binary and source files
%global _binary_filedigest_algorithm 1
%global _source_filedigest_algorithm 1
%global _source_payload       w9.gzdio
%global _binary_payload       w9.gzdio
%define SCMURL git://git.onelab.eu/util-vserver-pl.git@util-vserver-pl-0.4-29
# included from util-vserver-pl.spec
%define name	util-vserver-pl
%define version 0.4
%define taglevel 29

%define release	%{taglevel}%{?pldistro:.%{pldistro}}%{?date:.%{date}}

%define python_sitearch %( python -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)" )

Summary: PlanetLab extensions to util-vserver
Name: %{name}
Version: %{version}
Release: %{release}
License: GPL
Group: System Environment/Base
Source0: %{name}-%{version}.tar.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

Vendor: PlanetLab
Packager: PlanetLab Central <support@planet-lab.org>
Distribution: PlanetLab %{plrelease}
URL: %{SCMURL}

Requires: util-vserver util-vserver-core util-vserver-build util-vserver-sysv
Provides: util-vserver-python = %{version}-%{release}
Obsoletes: util-vserver-py32 resman
BuildRequires: libnl libnl-devel
BuildRequires: python python-devel
BuildRequires: util-vserver-core util-vserver-devel
BuildRequires: autoconf automake libtool

%description
This package contains all PlanetLab extensions to util-vserver.

%prep
%setup -q
autoreconf -fi


%build
%configure
make


%install
rm -fr %{buildroot}
make DESTDIR=%{buildroot} install

mkdir %{buildroot}/bin
ln -s ..%{_sbindir}/vsh %{buildroot}/bin/vsh

rm -f %{buildroot}%{python_sitearch}/vserverimpl.a
rm -f %{buildroot}%{python_sitearch}/vserverimpl.la

# Generate file list for python package
find "%{buildroot}" -name '*.py' | { while read FILE; do
	f="${FILE#%{buildroot}}"
	echo "${f}"
	# need to touch these files, as they are not produced on FC4 or below
	touch ${FILE}c
	touch ${FILE}o
	echo %%ghost "${f}c"
	echo %%ghost "${f}o"
done } > %name-python.list


%post
# add /bin/vsh to list of secure shells
if [ ! -f /etc/shells ] || ! grep -q '^/bin/vsh$' /etc/shells ; then
	echo /bin/vsh >> /etc/shells
fi

# Migrate old style vservers to new style
pushd /etc/vservers
for i in `ls /etc/vservers` 
do 
        if grep -rq "^0\.0\.0\.0" "$i/interfaces/"; then
	        # set nflags
		echo "persistent,lback_allow" > $i/nflags 
		/usr/sbin/nattribute --set --nid `cat $i/context` --flag lback_allow
	
	        # set cflags
		echo -e "persistent\n~info_init" > $i/cflags
		/usr/sbin/vattribute --set --xid `cat $i/context` --flag ~sched_hard
	
		# deprecated
		rm -f $i/flags
	
	        # remove 16mb tmp restrictions
		sed -i -e '/tmpfs\tsize=16m/d' $i/fstab
	
	        # enable mount namespaces
		rm -f $i/nonamespace
		
	        # enable IP forwarding
		mkdir -p $i/sysctl/0 
		echo net.ipv4.ip_forward > $i/sysctl/0/setting
		echo 1 > $i/sysctl/0/value

	        # create missing interface files/directories
        	mkdir -p $i/interfaces/0 
		hostname -i > $i/interfaces/0/ip
		touch $i/interfaces/0/nodev 

        	mkdir -p $i/interfaces/1
        	echo -e "127.0.0.1" > $i/interfaces/1/ip
        	touch $i/interfaces/1/nodev
	fi
done
popd

%postun
# 0 = erase, 1 = upgrade
if [ "$1" = 0 ] ; then
	perl -i -n -e 'next if /^\/bin\/vsh$/; print' /etc/shells
fi


%clean
rm -fr %{buildroot}


%files -f %name-python.list
%defattr(-,root,root,-)
%{_sbindir}/disklimit
%{_sbindir}/vuseradd
%{_sbindir}/vuserdel
%{python_sitearch}/vserverimpl.so
%{_sbindir}/vip6-autod
%{_sysconfdir}/init.d/vip6-autod

%attr(4755,root,root) %{_sbindir}/vsh
/bin/vsh
%{_mandir}/man8/vsh.8*

%changelog
* Sat Mar 09 2013 Stephen Soltesz <soltesz@opentechinstitute.org> - util-vserver-pl-0.4-29

* Tue Aug 28 2012 Andy Bavier <acb@cs.princeton.edu> - util-vserver-pl-0.4-28
- Bugfix for IPv6, ported from 0.3 branch

* Thu Jul 19 2012 Thierry Parmentelat <thierry.parmentelat@sophia.inria.fr> - util-vserver-pl-0.4-27
- bwlimit now ships with plnode-utils

* Tue Jun 07 2011 Thierry Parmentelat <thierry.parmentelat@sophia.inria.fr> - util-vserver-pl-0.4-26
- added support for loopback isolation

* Wed Mar 23 2011 S.Çağlar Onur <caglar@verivue.com> - util-vserver-pl-0.4-25
- vuserdel doesn't handle new vserver features that we are using like mount namespaces and/or cgroups, so it silently fails most of the time. Remove old code and start to use vserver provided tools

* Thu Mar 10 2011 S.Çağlar Onur <caglar@verivue.com> - util-vserver-pl-0.4-24
- * associate SSH processes with the appropriate cgroup
- *  migrate only when neccessary

* Wed Mar 02 2011 S.Çağlar Onur <caglar@verivue.com> - util-vserver-pl-0.4-23
- remove hardcoded nproc.hard limit as it shouldn't be hardcoded

* Wed Feb 02 2011 Thierry Parmentelat <thierry.parmentelat@sophia.inria.fr> - util-vserver-pl-0.4-22
- pass device to bwlimit

* Wed Dec 01 2010 Thierry Parmentelat <thierry.parmentelat@sophia.inria.fr> - util-vserver-pl-0.4-21
- force remove nonamespace

* Tue Oct 12 2010 S.Çağlar Onur <caglar@cs.princeton.edu> - util-vserver-pl-0.4-20
- Fix the segfault caused by existing TUN device

* Fri Aug 13 2010 S.Çağlar Onur <caglar@cs.princeton.edu> - util-vserver-pl-0.4-19
- Fix syntax error

* Mon Aug 09 2010 S.Çağlar Onur <caglar@cs.princeton.edu> - util-vserver-pl-0.4-18
- migrate old style interface files to new style

* Wed Jul 28 2010 S.Çağlar Onur <caglar@cs.princeton.edu> - util-vserver-pl-0.4-17
- Some dead code removed from repository

* Mon Jul 19 2010 S.Çağlar Onur <caglar@cs.princeton.edu> - util-vserver-pl-0.4-16
- * use system-wide umask
- * enable set_ipaddresses_config function
- * set more default values

* Mon Jul 12 2010 Thierry Parmentelat <thierry.parmentelat@sophia.inria.fr> - util-vserver-pl-0.4-15
- new constant VC_LIM_INFINITY

* Tue Jul 06 2010 S.Çağlar Onur <caglar@cs.princeton.edu> - util-vserver-pl-0.4-14
- fix setting cpu_share for slices

* Thu Jun 24 2010 S.Çağlar Onur <caglar@cs.princeton.edu> - util-vserver-pl-0.4-13
- start to use mount namespaces

* Tue Jun 22 2010 Thierry Parmentelat <thierry.parmentelat@sophia.inria.fr> - util-vserver-pl-0.4-12
- initscripts are ignored - handled by nodemanager and triggered by rc

* Thu Jun 17 2010 Baris Metin <Talip-Baris.Metin@sophia.inria.fr> - util-vserver-pl-0.4-11
- sliver name as the last argument to initscript

* Tue Jun 01 2010 S.Çağlar Onur <caglar@cs.princeton.edu> - util-vserver-pl-0.4-10
- remove tmpfs mounted /tmp

* Fri May 14 2010 S.Çağlar Onur <caglar@cs.princeton.edu> - util-vserver-pl-0.4-9
- change flags without restarting the vservers

* Thu May 13 2010 S.Çağlar Onur <caglar@cs.princeton.edu> - util-vserver-pl-0.4-8
- Migrate old style vservers to new style

* Thu May 13 2010 Talip Baris Metin <Talip-Baris.Metin@sophia.inria.fr> - util-vserver-pl-0.4-7
- chroot_call fix

* Wed May 12 2010 Talip Baris Metin <Talip-Baris.Metin@sophia.inria.fr> - util-vserver-pl-0.4-6
- fix initscript issues

* Mon May 10 2010 S.Çağlar Onur <caglar@cs.princeton.edu> - util-vserver-pl-0.4-5

* Mon May 10 2010 Talip Baris Metin <Talip-Baris.Metin@sophia.inria.fr> - util-vserver-pl-0.4-4
- merged trellis branch to trunk

* Wed Feb 24 2010 Marc Fiuczynski <mef@cs.princeton.edu> - util-vserver-pl-0.3-27
- Need to print the exception string as part of the self.log, or else we
- get a wrong number of argument error.

* Wed Feb 24 2010 Daniel Hokka Zakrisson <daniel@hozac.com> - util-vserver-pl-0.3-26
- This is outputted for some reason.

* Tue Feb 23 2010 Daniel Hokka Zakrisson <daniel@hozac.com> - util-vserver-pl-0.3-25
- Don't set bwlimits if they're disabled.
- Don't cleanup /var of running slivers.

* Tue Feb 23 2010 Marc Fiuczynski <mef@cs.princeton.edu> - util-vserver-pl-0.3-24
- - openfd -> nofile

* Tue Feb 16 2010 Talip Baris Metin <Talip-Baris.Metin@sophia.inria.fr> - util-vserver-pl-0.3-23
- call bwlimit init in postinstall.

* Fri Jan 29 2010 S.Çağlar Onur <caglar@cs.princeton.edu> - util-vserver-pl-0.3-22
- move the HTB tree one level down for DRL

* Mon Jan 25 2010 Thierry Parmentelat <thierry.parmentelat@sophia.inria.fr> - util-vserver-pl-0.3-21
- logging policy only; use /var/log/nm instead of boot.log, and give more details with (un)setdlimit

* Thu Nov 19 2009 Daniel Hokka Zakrisson <daniel@hozac.com> - util-vserver-pl-0.3-20
- Log the error as well.

* Wed Oct 28 2009 Daniel Hokka Zakrisson <daniel@hozac.com> - util-vserver-pl-0.3-19
- Set ulimits for NM too.

* Tue Oct 20 2009 Baris Metin <Talip-Baris.Metin@sophia.inria.fr> - util-vserver-pl-0.3-18
- bwlimit.set() now accepts the device and don't assume that it's eth0

* Tue Aug 04 2009 Faiyaz Ahmed <faiyaza@cs.princeton.edu> - util-vserver-pl-0.3-17
- Fix runlevel clean up after reboot.
- Fix runlevel setup to reflect proper runlevel.

* Thu Jan 29 2009 Faiyaz Ahmed <faiyaza@cs.princeton.edu> - util-vserver-pl-0.3-16
- supports disabling htbs.

* Wed Oct 29 2008 Marc E. Fiuczynski <mef@cs.princeton.edu> - util-vserver-pl-0.3-15
- added in support for rlimit MEM_LOCK
- fixed bug in reading -1 value from VSERVERCONF/<guest>/rlimits/memlock.hard file
- reduced compilation warnings

* Tue Sep 23 2008 Thierry Parmentelat <thierry.parmentelat@sophia.inria.fr> - util-vserver-pl-0.3-14
- configure/make check the version of libnl and can cope with either 1.1 or 1.0-pre6
- as centos does not have any of these, do build vip6-autod on fedora only

* Wed Sep 17 2008 Faiyaz Ahmed <faiyaza@cs.princeton.edu> - util-vserver-pl-0.3-13
- Remove current bw limit checks before issuing tc.

* Fri Aug 29 2008 Daniel Hokka Zakrisson <daniel@hozac.com> - util-vserver-pl-0.3-12
- libnl 1.1 fixups.

* Thu Aug 28 2008 Thierry Parmentelat <thierry.parmentelat@sophia.inria.fr> - util-vserver-pl-0.3-11
- reads /etc/vservers/<name>/personality and behaves accordingly
- nicer formatting for byte rates

* Sun Aug 17 2008 Daniel Hokka Zakrisson <daniel@hozac.com> - util-vserver-pl-0.3-10
- FUSE support.

* Fri Aug 01 2008 Faiyaz Ahmed <faiyaza@cs.princeton.edu> - util-vserver-pl-0.3-9
- Check running values before issuing set or on.  If same, disregard to save on forks.

* Fri Jul 25 2008 Faiyaz Ahmed <faiyaza@cs.princeton.edu> - util-vserver-pl-0.3-8
- exempt_init shouldn't modify iptables rules.  Instead, only manipulate ipset.  Assume iptables rules are setup properly (now downloaded from nodeconfig/PlanetLabConf for I2 and defaulted to iptables/planetlab-config for all other nodes).

* Tue Jul 22 2008 Faiyaz Ahmed <faiyaza@cs.princeton.edu> - util-vserver-pl-0.3-7
- Init exempt flows into "mangle" table.

* Fri Jun 27 2008 Daniel Hokka Zakrisson <daniel@hozac.com> - util-vserver-pl-0.3-6
- Optimized the case where it's already running.

* Thu Jun 26 2008 Daniel Hokka Zakrisson <daniel@hozac.com> - util-vserver-pl-0.3-5
- Ignore ESRCH for setname.
- Always create the home directory, regardless of configuration settings.

* Fri May 09 2008 Stephen Soltesz <soltesz@cs.princeton.edu> - util-vserver-pl-0.3-4
- 

* Wed Apr 23 2008 Stephen Soltesz <soltesz@cs.princeton.edu> - util-vserver-pl-0.3-3
- Added support for vc_{set|get}_vhi_name() via util-vserver-pl.
- Adding a tag to include in the 4.2rc2
- 

* Wed Apr 16 2008 Faiyaz Ahmed <faiyaza@cs.princeton.edu> - util-vserver-pl-0.3-2
- 
- * Can write vcVHI_CONTEXT
- * CAP_NET_BIND_SERVICE is special, in all cases. 
- * Check if already mounted before mounting fs in vserver
- * Optimized 0.0.0.0 case
- * Removed vcached.  DEPRECATED
- 

* Fri Nov 30 2007 Daniel Hokka Zakrisson <daniel@hozac.com> - 0.1-1
- Initial release

%define module_current_branch 0.3
